Tool: update_deny_policy
Updates an existing deny policy attached to a Google Cloud project. Organizations and folders are not supported.
Use this tool to modify deny rules, denied principals, exceptions, or display names. Perform a read-modify-write pattern by fetching the latest policy via get_deny_policy and providing the current etag to prevent concurrency conflicts. Updating a deny policy is asynchronous and returns a long-running operation. Use the get_deny_policy_status tool to check for operation completion.
This tool requires the policy parameter, which is the updated deny policy containing name, display_name, rules, and the current etag.
This tool returns a long-running operation resource whose resolution status can be tracked with get_deny_policy_status.
The following code sample shows how to use curl to call the update_deny_policy MCP tool.
| Curl Request |
|---|
curl --location 'https://iam.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "update_deny_policy", "arguments": { // Provide these details according to the MCP tool specification. } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request message for UpdatePolicy.
UpdatePolicyRequest
| JSON representation |
|---|
{
"policy": {
object ( |
| Fields | |
|---|---|
policy |
Required. The policy to update. To prevent conflicting updates, the |
Policy
| JSON representation |
|---|
{
"name": string,
"uid": string,
"kind": string,
"displayName": string,
"annotations": {
string: string,
...
},
"etag": string,
"createTime": string,
"updateTime": string,
"deleteTime": string,
"rules": [
{
object ( |
| Fields | |
|---|---|
name |
Immutable. The resource name of the The attachment point is identified by its URL-encoded full resource name, which means that the forward-slash character, For organizations and folders, use the numeric ID in the full resource name. For projects, requests can use the alphanumeric or the numeric ID. Responses always contain the numeric ID. |
uid |
Immutable. The globally unique ID of the |
kind |
Output only. The kind of the |
displayName |
A user-specified description of the |
annotations |
A key-value map to store arbitrary metadata for the An object containing a list of |
etag |
An opaque tag that identifies the current version of the If this field is present in a |
createTime |
Output only. The time when the Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
updateTime |
Output only. The time when the Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
deleteTime |
Output only. The time when the Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
rules[] |
A list of rules that specify the behavior of the |
AnnotationsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
Timestamp
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
nanos |
Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |
PolicyRule
| JSON representation |
|---|
{ "description": string, // Union field |
| Fields | |
|---|---|
description |
A user-specified description of the rule. This value can be up to 256 characters. |
Union field
|
|
denyRule |
A rule for a deny policy. |
DenyRule
| JSON representation |
|---|
{
"deniedPrincipals": [
string
],
"exceptionPrincipals": [
string
],
"deniedPermissions": [
string
],
"exceptionPermissions": [
string
],
"denialCondition": {
object ( |
| Fields | |
|---|---|
deniedPrincipals[] |
The identities that are prevented from using one or more permissions on Google Cloud resources. This field can contain the following values:
|
exceptionPrincipals[] |
The identities that are excluded from the deny rule, even if they are listed in the This field can contain the same values as the |
deniedPermissions[] |
The permissions that are explicitly denied by this rule. Each permission uses the format |
exceptionPermissions[] |
Specifies the permissions that this rule excludes from the set of denied permissions given by The excluded permissions can be specified using the same syntax as |
denialCondition |
The condition that determines whether this deny rule applies to a request. If the condition expression evaluates to Each deny rule is evaluated independently. If this deny rule does not apply to a request, other deny rules might still apply. The condition can use CEL functions that evaluate resource tags. Other functions and operators are not supported. |
Expr
| JSON representation |
|---|
{ "expression": string, "title": string, "description": string, "location": string } |
| Fields | |
|---|---|
expression |
Textual representation of an expression in Common Expression Language syntax. |
title |
Optional. Title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs which allow to enter the expression. |
description |
Optional. Description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI. |
location |
Optional. String indicating the location of the expression for error reporting, e.g. a file name and a position in the file. |
Output Schema
This resource represents a long-running operation that is the result of a network API call.
Operation
| JSON representation |
|---|
{ "name": string, "metadata": { "@type": string, field1: ..., ... }, "done": boolean, // Union field |
| Fields | |
|---|---|
name |
The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the |
metadata |
Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any. An object containing fields of an arbitrary type. An additional field |
done |
If the value is |
Union field result. The operation result, which can be either an error or a valid response. If done == false, neither error nor response is set. If done == true, exactly one of error or response can be set. Some services might not provide the result. result can be only one of the following: |
|
error |
The error result of the operation in case of failure or cancellation. |
response |
The normal, successful response of the operation. If the original method returns no data on success, such as An object containing fields of an arbitrary type. An additional field |
Any
| JSON representation |
|---|
{ "typeUrl": string, "value": string } |
| Fields | |
|---|---|
typeUrl |
Identifies the type of the serialized Protobuf message with a URI reference consisting of a prefix ending in a slash and the fully-qualified type name. Example: type.googleapis.com/google.protobuf.StringValue This string must contain at least one The prefix is arbitrary and Protobuf implementations are expected to simply strip off everything up to and including the last All type URL strings must be legal URI references with the additional restriction (for the text format) that the content of the reference must consist only of alphanumeric characters, percent-encoded escapes, and characters in the following set (not including the outer backticks): In the original design of |
value |
Holds a Protobuf serialization of the type described by type_url. A base64-encoded string. |
Status
| JSON representation |
|---|
{ "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } |
| Fields | |
|---|---|
code |
The status code, which should be an enum value of |
message |
A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the |
details[] |
A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field |
Tool Annotations
Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.
Along with the title string, the following boolean hints are defined as follows:
readOnlyHint: If true, the tool doesn't modify its environment. Default: false.destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.
Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ❌ | Open World Hint: ❌